<?php

namespace Ig\IgCookies\Controller;

use Ig\IgCookies\Domain\Model\Log;
use Ig\IgCookies\Domain\Repository\LogRepository;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use TYPO3\CMS\Core\Http\HtmlResponse;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\Generic\PersistenceManager;

/**
 * @package cookies
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 */
class LogController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

    /**
     * @var \Ig\IgCookies\Domain\Repository\LogRepository
     */
    public $logRepository = null;


    /**
     * action list: list cookies
     *
     * @return void
     */
    public function listAction() {
      $searchString = $this->request->hasArgument('searchString') ? $this->request->getArgument('searchString') : '';
        $this->logRepository = GeneralUtility::makeInstance(LogRepository::class);
        $logs = $this->logRepository->findBySearch($searchString);
        $this->view->assign('logs', $logs);
        $this->view->assign('searchString', $searchString);
    }
    /**
     * Create log (Called per Ajax)
     *
     * @return void
     */
    public function createAction() {
      $log = GeneralUtility::makeInstance(Log::class );
      $log->setIpAddress( $_SERVER['REMOTE_ADDR'] );
      $log->setBrowser( $_SERVER['HTTP_USER_AGENT'] );

      /*
      $log = GeneralUtility::makeInstance(
            Log::class,
            new \DateTime(),
            $_SERVER['REMOTE_ADDR'],
            $_SERVER['HTTP_USER_AGENT']
        );
      */
        $this->logRepository->add($log);

        return 'DONE';
    }

    public function ajaxAction( ServerRequestInterface $request )
    {
      $log = GeneralUtility::makeInstance(Log::class );
      $log->setIpAddress( $_SERVER['REMOTE_ADDR'] );
      $log->setBrowser( $_SERVER['HTTP_USER_AGENT'] );

      if(!empty($request->getQueryParams()['categories'])) {
          $log->setCategories(implode(',', $request->getQueryParams()['categories']));
      }

      //var_dump($log);exit(0);
      $logRepository= GeneralUtility::makeInstance(LogRepository::class);
      $logRepository->add($log);

      $persistenceManager = GeneralUtility::makeInstance(PersistenceManager::class);
      $persistenceManager->persistAll();
      //.$log->getLogDate()
      //file_put_contents('/var/www/citech/cookie.log', $log->getIpAddress() ."\t" . $log->getBrowser() ."\t" . $log->getLogDate()->Format('Y-d-m H:i:s') ."\t" . $log->getUid() ."\n", FILE_APPEND );
      //$debug= $_SERVER['REMOTE_ADDR']  .'='. $log->getIpAddress() .'('.') uid='.$log->getUid();
      return new HtmlResponse('done');
    }


}
