$(function() {
    var analyticsCookies = ['_gid', '_ga', '_gat'];
    var cookieValue = 2;

    function getCookieNamesByMatch(regex) {
      var cs=document.cookie.split(/;\s*/), ret=[], i;
      for (i=0; i<cs.length; i++) {
        if (cs[i].match(regex)) {
            var cookieArr = cs[i].split('=');
            var cookieName = '';
            if(cookieArr.length) {
                cookieName = cookieArr[0];
            }
            ret.push(cookieName);
        }
      }
      return ret;
    }


    // Domain namen ermitteln ohne Subdomains für Google Analytics Cookies
    function getDomain() {
        var domain = document.domain;
        var domainArr = domain.split('.');
        while(domainArr.length > 2) {
            domainArr.shift();
            domain = '.' + domainArr.join('.');
        }
        return domain;
    }
    var domain = getDomain();

    function removeAnalyticsCookies() {
        // Remove cookies for analytics
        for (var i = 0; i < analyticsCookies.length; i++) {
            var cookie = analyticsCookies[i];
            $.removeCookie(cookie, {path: '/', domain: domain});
        }
        var remainingCookies = getCookieNamesByMatch(/^_ga_\d+=/); // Get google analytics cookie with measurement id
        for (var i = 0; i < remainingCookies.length; i++) {
            var cookie = remainingCookies[i];
            $.removeCookie(cookie, {path: '/', domain: domain});
        }
        if(typeof window.gaOptout === 'function') {
            gaOptout(1);
        }
    }

    function disableCookies() {
        // Disable cookies
        $.cookie("ig_cookies_disable", 1, {
            expires: 365,
            path: '/'
        });
    }

    function closeCookieConsent() {
        // Deactivate cookie hint
        $.cookie("ig_cookies_accepted", cookieValue, {
            expires: 365,
            path: '/'
        });
        // Close cookie hint
        $("#ig_cookies_container").hide();
        $("body").removeClass('ig_cookies');
    }

    function activateAnalytics() {
        if(typeof window.gaOptin === 'function') {
            gaOptin(1);
        }
        if(typeof window.initGoogleAnalytics === 'function') {
            initGoogleAnalytics();
        }
    }

    function logAccept($this) {
        logUrl = $this.data('page');
        if (logUrl) {
            $.ajax({
                url: logUrl,
                context: document.body
            });
        }
    }

    if(!$('.ig-cookies-settings').length) {
        // Show consent if not on settings page
        if ($.cookie("ig_cookies_accepted") != cookieValue) {
            $("#ig_cookies_container").show();
            $("body").addClass('ig_cookies');
        }
        $(".ig_cookies_disable").click(function(e) {
            e.preventDefault();
            closeCookieConsent();
            removeAnalyticsCookies();
            disableCookies();
        });


        $(".ig_cookies_ok").click(function(e) {
            e.preventDefault();
            // Set cookie
            closeCookieConsent();
            activateAnalytics();
            logAccept($(this));
        });
    } else {
        if(!$.cookie("ig_cookies_disable") && $.cookie("ig_cookies_accepted") == 2) {
            $('#cookies-analytics').attr('checked', true);
            $('#cookies-analytics').prop('checked', true);
        }
        $('.ig-cookies-settings form').on('submit', function(e) {
            e.preventDefault();

            if($('#cookies-analytics').length) {
                var disabled = true;
                closeCookieConsent();

                if($('#cookies-analytics').is(':checked')) {
                    $.removeCookie("ig_cookies_disable", {path: '/'});
                    activateAnalytics();
                    logAccept($(".ig_cookies_ok"));
                    disabled = false;
                }

                if(disabled) {
                    removeAnalyticsCookies();
                    disableCookies();
                }
            }
        });
    }
});
